{{
File  :  RGB_LED_Matrix_Driver_Simple3.spin
Author:  John Zhong
Company: SimplyTronics
Version: 1.0
Date   : 2012-10-31

  Fixed the bug, the BMP files gererated by Photoshop can be display right.   

   This driver assumes the modules were assembled as the Device ID table(128x128 pixels).
   Basic fucntions test driver

}}                                      

_ModeNormal                =    0
_ModeInverse               =    1
_ModeOverlay               =    2
_ModeMinuslay              =    3
_ModeGray                  =    4
_Modes                     =    _ModeGray + 1



''---------------------------[ Command List ]------------------------
'' It's recommend to wait 2 seconds at the begining of Program before sending the any commands. 



_UpdateScreen              =   $00                             
_SetPointerX               =   $03                                             
_SetPointerY               =   $04                                   
_SendData                  =   $05                            
_SetWindowsBoundStartX     =   $06           ' Notice: After Set the Windows Bound, the PointerX and PointerY     
_SetWindowsBoundStartY     =   $07           '         will Point to Windows Bound Start X and Start Y Automatic      
_SetWindowsBoundEndX       =   $08           '  
_SetWindowsBoundEndY       =   $09           '    
_Copy2bxGDRAM              =   $0A                 
_DisplaybxGDRAM            =   $0B                   
_fillGDRAM                 =   $0C           ' Fill the GDRAM with Data(User Defined) TxCMD(_FillGDRAM, $01)              
{ 
_RollLeft                  =   $0D
_RollRight                 =   $0E
_RollUp                    =   $0F
_RollDown                  =   $10  
}

_SetForegroundColor        =   $11     
_SetBackgroundColor        =   $12    
_DisplayChar0508           =   $13     
_DisplayChar0816           =   $14      

_DisplayChar0508NBG        =   $15              ' NBG Stand for no BackGround   
_DisplayChar0816NBG        =   $16              ' If you want to Clear these character in the Matrix please use the Command _DisplaybxGDRAM(  ) above 
_DisplayPropellerHat       =   $17              
_DisplayPropellerHatNBG    =   $18              
_DisplayParallaxLogo       =   $19              
_DisplayParallaxLogoNBG    =   $1A              
_DisplayCustomerBMP1       =   $1B                    
_DisplayCustomerBMP2       =   $1C                   
_DrawDot                   =   $1D                    

_SetLineEndX               =   $1E                   
_SetLineEndY               =   $1F                 
_DrawLine                  =   $20             

_SetRadius                 =   $21      
_DrawCircle                =   $22

_SavePictureEeprom         =   $23      
_LoadPictureEeprom         =   $24
                                  
_ScreenColorInverse        =   $30   
_ScreenOverLay             =   $31   
_ScreenMinusLay            =   $32

_Reset                     =   $A0      
_SetBaudRate               =   $A1          
_SetMode                   =   $A2
_GetVerison                =   $A6
_GetScreenSize             =   $A7
_ChangeScreenSize          =   $A8            
_GetDeviceID               =   $A9    
_ChangeDeviceID            =   $AA
_GetSystemConfiguration    =   $AB

OBJ

  Serial : "FullDuplexSerial"
  BMP    : "Read_BMP_Files_info"   
  
var
                       
long  pinRx, pinTx
long  Baudrate

pub Start(pin_Rx,pin_Tx, Baud_Rate)

'' Initialize the Hardware

    pinRx := pin_Rx
    pinTx := pin_Tx

    BaudRate := Baud_Rate                                     
    Serial.Start(pinRx,pinTx,0, BaudRate)
    waitcnt(clkfreq/50 + cnt)  

pub SetMode(ScreenMode)

    TxDatPackHead(_SetMode, ScreenMode)  
    
pub ChangeBaudRate(BdRt)

'' change Baudrate, default baudrate is 19200, Max 57600
'' Notice: After change the Device ID, the module will reset. And you have
''         to wait for the Module start up
    
    TxDatPackHead(_SetBaudRate, BdRt)
    waitcnt(clkfreq/100 + cnt)
    Serial.Start(pinRx,pinTx,0,BdRt)
    BaudRate := BdRt
    

pub ChangeScreenSize(NewScreenSize)
'' Change Screen Size
'' you have to reset the module to active the new setting

   TxDatPackHead(_ChangeScreenSize, NewScreenSize) 


pub ChangeDeviceID(NewID)

'' Change DeviceID OldID to NewID
'' You can get and check the deviceID with PropPlug and PST, the Baudrate would be 19200 bps
'' the RGB LED Matrix will send the ID out to PropPlug
'' you have to reset the module to active the new setting

    TxDatPackHead(_ChangeDeviceID, NewID)

pub Reset

    TxDatPackHead(_Reset,$00)

pub UpdateScreen

    TxDatPackHead(_UpdateScreen, $00)
        
pub Dot(X0,Y0,DotColor)

    SetPointer(X0,Y0)             
    TxDatPackHead(_DrawDot, DotColor)
                      
pub Line(X0,Y0,X1,Y1,LineColor)

      SetPointer(X0,Y0)             
      TxDatPackHead(_SetLineEndX, X1)      
      TxDatPackHead(_SetLineEndY, Y1)             
      TxDatPackHead(_DrawLine, LineColor)

pub Circle(X,Y,R,CircleColor)

      SetPointer(X,Y)             
      TxDatPackHead(_SetRadius, R)             
      TxDatPackHead(_DrawCircle, CircleColor)
      
pub SetColors(ForegroundColor,BackgroundColor)
      
      TxDatPackHead(_SetForegroundColor, ForegroundColor)    
      TxDatPackHead(_SetBackgroundColor, BackgroundColor)      
               
pub ASCII_0508(DisplayCharacter,StartX,StartY,ForegroundColor,BackgroundColor)
            
      TxDatPackHead(_SetForegroundColor, ForegroundColor)    
      TxDatPackHead(_SetBackgroundColor, BackgroundColor)    
      Setpointer(StartX,StartY)
      TxDatPackHead(_DisplayChar0508, DisplayCharacter)

pub ASCII_0508NBG(DisplayCharacter,StartX,StartY,ForegroundColor)  
     
      TxDatPackHead(_SetForegroundColor, ForegroundColor)             
      Setpointer(StartX,StartY)
      TxDatPackHead(_DisplayChar0508NBG, DisplayCharacter)

      
pub ASCII_0816(DisplayCharacter,StartX,StartY,ForegroundColor,BackgroundColor)
            
      TxDatPackHead(_SetForegroundColor, ForegroundColor)    
      TxDatPackHead(_SetBackgroundColor, BackgroundColor)    
      Setpointer(StartX,StartY)
      TxDatPackHead(_DisplayChar0816, DisplayCharacter)

pub ASCII_0816NBG(DisplayCharacter,StartX,StartY,ForegroundColor)  
     
      TxDatPackHead(_SetForegroundColor, ForegroundColor)             
      Setpointer(StartX,StartY)
      TxDatPackHead(_DisplayChar0816NBG, DisplayCharacter)            
           
pub ClearASCII_NBG
     
    TxDatPackHead(_DisplaybxGDRAM, 00)
         
pub ClearScreen(CColor)

    TxDatPackHead(_fillGDRAM, CColor)
    
pub DisplayBMPFile24bpp(X0,Y0,BMPFileAddr) | Temp, Windex, Hindex, BMPHeight, BMPWidth, WordAlignment, RGBDataSize

   if BMP.RdType(BMPFileAddr) <> $4D42           ' "BM"  
      return
      
   if BMP.RdBitCount(BMPFileAddr) <> 24          ' 24 Bit Per Pixel
      return

   if BMP.RdCompression(BMPFileAddr) <>  0       ' Compress?
      return 
      
   BMPWidth      :=  BMP.RdWidth(BMPFileAddr)
   WordAlignment :=  BMPWidth & $0000_0003       ' Word alignment
   BMPHeight     :=  BMP.RdHeight(BMPFileAddr)
   RGBDataSize   :=  BMPHeight * (BMPWidth * 3 + WordAlignment)

                     
   SetWindows(X0, Y0, X0-1+BMPWidth, Y0-1+BMPHeight)
   
   'Temp   :=  BMP.RdSize(BMPFileAddr) - WordAlignment - (BMPWidth * 3) 
   Temp   :=  BMP.RdDataOffset(BMPFileAddr) + RGBDataSize - WordAlignment - (BMPWidth * 3)
     
   TxDataLength(RGBDataSize - (BMPHeight * WordAlignment))
   
   repeat Hindex from 0 to BMPHeight - 1
        repeat Windex from 0  to   BMPWidth-1
         Serial.Tx(byte[BMPFileAddr][Temp++])     ' R
         Serial.Tx(byte[BMPFileAddr][Temp++])     ' G
         Serial.Tx(byte[BMPFileAddr][Temp++])     ' B   
                                  
    Temp := Temp  -  WordAlignment - (BMPWidth*6)   
{                     
pub DisplayBMPFile16bpp(X0,Y0,BMPFileAddr) | Temp, Windex, Hindex, BMPHeight, BMPWidth, WordAlignment, convert, toRGB

   BMPWidth      :=  BMP.RdWidth(BMPFileAddr)
   WordAlignment :=  (BMPWidth<<1)//4                         ' Word alignment
   BMPHeight     :=  BMP.RdHeight(BMPFileAddr)
                     
   SetWindows(X0, Y0, X0-1+BMPWidth, Y0-1+BMPHeight)
   
   Temp   := BMP.RdSize(BMPFileAddr) -  WordAlignment - BMPWidth<<1
   
   repeat Hindex from 0  to BMPHeight - 1
        repeat Windex from 0  to   BMPWidth-1
              convert := byte[BMPFileAddr][Temp++] | byte[BMPFileAddr][Temp++]<<8
              toRGB  :=(Convert & $7FE0)<<1
              convert := toRGB | (Convert & $003F) 
              dot(X0 + Windex, Y0 + Hindex , convert)
              
    Temp := Temp  -  WordAlignment - (BMPWidth<<2) }  
      

pub CopyGDRAM2(GDRAMx)

   TxDatPackHead(_Copy2bxGDRAM, GDRAMx)
   
pub DisplayGDRAM(GDRAMx)
            
   TxDatPackHead(_DisplaybxGDRAM, GDRAMx)

pub DisplayCustomerBMP1(X0,Y0)

   SetPointer(X0,Y0) 
   TxDatPackHead(_DisplayCustomerBMP1, $0000)    

pub DisplayCustomerBMP2(X0,Y0)

   SetPointer(X0,Y0) 
   TxDatPackHead(_DisplayCustomerBMP2, $0000)

pub DisplayPropellerHat(X0,Y0)

   SetPointer(X0,Y0)
   TxDatPackHead(_DisplayPropellerHat, $0000)

pub DisplayPropellerHatNBG(X0,Y0)
                     
   SetPointer(X0,Y0)
   TxDatPackHead(_DisplayPropellerHatNBG, $00)
   
pub DisplayPropellerlogoNBG(X0,Y0)
                     
   SetPointer(X0,Y0)
   TxDatPackHead(_DisplayParallaxLogoNBG, $00)
   
pub DisplayParallaxlogo(X0,Y0)

    SetPointer(X0,Y0)    
    TxDatPackHead(_DisplayParallaxLogo, $00)
            
pub SavePictureEeprom

   TxDatPackHead(_SavePictureEeprom, $00)
   
pub LoadPictureEeprom

    TxDatPackHead(_LoadPictureEeprom, $00)
                
pub ScreenInverse

    TxDatPackHead(_ScreenColorInverse, $0000)     
      
pub SetPointer(X,Y)  
     
     TxDatPackHead(_SetPointerX, X)
     TxDatPackHead(_SetPointerY, Y) 
     
Pub SetWindows(XStart,YStart,XEnd,YEnd)

     TxDatPackHead(_SetWindowsBoundStartX, XStart)
     TxDatPackHead(_SetWindowsBoundStartY, YStart)
     TxDatPackHead(_SetWindowsBoundEndX, XEnd)
     TxDatPackHead(_SetWindowsBoundEndY, YEnd)
     
 {    
pub TxLong(TLong)

    TxDatPackHead(_SendData, 4) 
    Serial.tx(TLong>>24)
    Serial.tx(TLong>>16)
    Serial.tx(TLong>>8)
    Serial.Tx(TLong)
    
pub TxWord(TWord)

    TxDatPackHead(_SendData, 2)
    Serial.tx(TWord>>8)
    Serial.Tx(TWord)  }
    
pub TxByte(TByte)

    Serial.tx(TByte)  
            
    
pub TxDataLength(DataLength)

    TxDatPackHead(_SendData, DataLength)    

Pub TxDatPackHead(Data_CMD,LengthValue)

     Serial.tx("P")
     Serial.tx("M")
     Serial.tx("T")
     Serial.tx("X")
     Serial.tx(Data_CMD)
     Serial.tx(LengthValue>>24)
     Serial.tx(LengthValue>>16)
     Serial.tx(LengthValue>>8)
     Serial.tx(LengthValue)
     